﻿Imports Microsoft.Win32

''' <summary>
''' calculator
''' </summary>
''' <remarks>Basic calculator that I added as an afterthought</remarks>
Public Class calculator

    Dim Num1 As Decimal
    Dim Num2 As Decimal
    Dim Memory As Decimal
    Dim Operation As String
    Dim isDecimal As Boolean
    Dim EraseNext As Boolean
    Dim doOperation As Boolean = True

    Private Sub any_numberButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
            oneButton.Click, twoButton.Click, threeButton.Click, fourButton.Click, fiveButton.Click, sixButton.Click, _
            sevenButton.Click, eightButton.Click, nineButton.Click, zeroButton.Click

        Dim btn As Button = TryCast(sender, Button)
        If displayLabel.Text = "0" Or EraseNext Then displayLabel.Text = String.Empty : EraseNext = False
        displayLabel.Text &= btn.Text

    End Sub

    Private Sub clearButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles clearButton.Click
        Num1 = 0
        Num2 = 0
        displayLabel.Text = "0"
        isDecimal = False
        EraseNext = False
    End Sub

    Private Sub backspaceButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles backspaceButton.Click
        Dim Disp As String = displayLabel.Text
        If Disp.Substring(Disp.Length - 1) = "." Then isDecimal = False
        If CDec(Disp) <> 0 Then displayLabel.Text = Disp.Remove(Disp.Length - 1)
        Disp = displayLabel.Text
        If Disp.Length = 0 Then displayLabel.Text = "0"
    End Sub

    Private Sub operationButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles plusButton.Click, minusButton.Click, divisionButton.Click, multiplicationButton.Click
        If Operation <> String.Empty And doOperation Then equalsButton.PerformClick()
        Dim btn As Button = TryCast(sender, Button)
        Operation = btn.Text
        Num1 = CDec(displayLabel.Text)
        EraseNext = True
        doOperation = True
        isDecimal = False
    End Sub

    Private Sub equalsButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles equalsButton.Click

        If doOperation Then Num2 = CDec(displayLabel.Text)
        Select Case Operation
            Case "+"
                displayLabel.Text = (Num1 + Num2).ToString
            Case "-"
                displayLabel.Text = (Num1 - Num2).ToString
            Case "/"
                displayLabel.Text = (Num1 / Num2).ToString
            Case "*"
                displayLabel.Text = (Num1 * Num2).ToString
            Case "^"
                displayLabel.Text = (Num1 ^ Num2).ToString
        End Select

        Num1 = CDec(displayLabel.Text)
        EraseNext = True
        doOperation = False
    End Sub

    Private Sub decimalButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles decimalButton.Click
        If isDecimal = False Then isDecimal = True : displayLabel.Text &= "."
    End Sub

    Private Sub anyButton_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        ' Keeps any button from being highlighted, looks nicer.
        displayLabel.Focus()
    End Sub

    Private Sub calculator_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For Each ctrl As Control In MyBase.Controls
            If TypeOf ctrl Is Button Then
                AddHandler ctrl.MouseUp, AddressOf anyButton_MouseUp
            End If
        Next
    End Sub

End Class