﻿Public Class chipPictureBox
    Inherits PictureBox

    Private img As New Bitmap(51, 51)

    ''' <summary>
    ''' Default constructor
    ''' </summary>
    ''' <remarks>Reshapes the control</remarks>
    Public Sub New()
        Me.DoubleBuffered = True
        Me.Size = New Size(51, 51)
        Dim gp As New Drawing2D.GraphicsPath
        gp.AddEllipse(New Rectangle(Point.Empty, New Size(50, 50)))
        Me.Region = New Region(gp)

        Dim gr As Graphics = Graphics.FromImage(img)
        gr.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
        gr.Clear(Color.Yellow)
        gr.FillEllipse(Brushes.Black, New Rectangle(New Point(10, 10), New Size(30, 30)))
        Me.Image = img
    End Sub

End Class
